=== debian/changelog ===
clblas (2.6-2) unstable; urgency=medium

  * d/control: remove ${shlibs:Depends} substitution from debug package
  * d/*-dev.install: use more generic expressions
  * d/rules: use stricter hardening
  * d/p: add patch to use Boost dynamic libraries
  * d/p: add patch fixing missing inclusion of stdlib

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 18 Aug 2015 19:55:19 +0100

clblas (2.6-1) unstable; urgency=medium

  * New upstream release.
  * d/patches: add patch fixing missing linkage with pthread.
  * Break fix-doxygen-settings.patch down to more specific patches:
    - fix-docs-output.patch,
    - use-system-mathjax.patch,
    - reproducible-build.patch.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 30 Jul 2015 17:29:37 +0100

clblas (2.4-3) unstable; urgency=medium

  * Add gbp.conf file.
  * Allow build with alternative OpenCL implementation. 

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 30 Jul 2015 11:49:05 +0100
