=== debian/control ===
Source: clblas
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Build-Depends: cmake,
               debhelper (>= 9),
               doxygen,
               libboost-program-options-dev,
               ocl-icd-opencl-dev | opencl-dev
Standards-Version: 3.9.6
Homepage: https://github.com/clMathLibraries/clBLAS
Vcs-Git: git://anonscm.debian.org/debian-science/packages/clblas.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/clblas.git

Package: libclblas-bin
Multi-Arch: foreign
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libclblas2 (= ${binary:Version})
Description: OpenCL BLAS library (executables)
 This library provides an implementation of the Basic Linear Algebra 
 Subprograms levels 1, 2 and 3, using OpenCL and optimized for AMD GPU 
 hardware.
 .
 This package provides the clBLAS executables.

Package: libclblas-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libclblas2 (= ${binary:Version})
Suggests: libclblas-doc
Description: OpenCL BLAS library (development files)
 This library provides an implementation of the Basic Linear Algebra 
 Subprograms levels 1, 2 and 3, using OpenCL and optimized for AMD GPU 
 hardware.
 .
 This package provides the clBLAS development files.

Package: libclblas-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
         libjs-jquery,
         libjs-mathjax
Description: OpenCL BLAS library (documentation)
 This library provides an implementation of the Basic Linear Algebra 
 Subprograms levels 1, 2 and 3, using OpenCL and optimized for AMD GPU 
 hardware.
 .
 This package provides the clBLAS documentation.

Package: libclblas2
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends} 
Pre-Depends: ${misc:Pre-Depends}
Description: OpenCL BLAS library (shared library)
 This library provides an implementation of the Basic Linear Algebra 
 Subprograms levels 1, 2 and 3, using OpenCL and optimized for AMD GPU 
 hardware.
 .
 This package provides the clBLAS shared library.

Package: libclblas2-dbg
Section: debug
Priority: extra
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         libclblas2 (= ${binary:Version})
Description: OpenCL BLAS library (debugging symbols)
 This library provides an implementation of the Basic Linear Algebra 
 Subprograms levels 1, 2 and 3, using OpenCL and optimized for AMD GPU 
 hardware.
 .
 This package provides the clBLAS debugging symbols.
