=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/clBLAS-$1\.tar\.gz/ \
  https://github.com/clMathLibraries/clBLAS/tags .*/v?(\d\S*)\.tar\.gz
